function install(varargin)
% 'mfile' 
% install('name','eigs')
  urlbase='http://www.math.univ-paris13.fr/~cuvelier/software/codes/fc-vfemp1/addon/';
  assert(nargin>=2)
  p = inputParser; 
  p.addParamValue('name', '', @ischar );
  p.addParamValue('version', '', @ischar );
  p.addParamValue('url', '', @ischar );
%  p.addParamValue('mfile','' , @ischar );
  p.parse(varargin{:});
  R=p.Results;
   
  if length(R.name)>0
    if length(R.version)==0
      V=GetVersions(urlbase,R.name);
    else
      V{1}=R.version;
    end
    if fc_tools.comp.isOctave()
      base=sprintf('ofc-vfemp1-%s-%s',R.name,V{1});
    else
      base=sprintf('mfc-vfemp1-%s-%s',R.name,V{1});
    end
    urlfile=[urlbase,R.name,filesep,V{1},filesep,base,'.tar.gz'];
    bool=checkversion(urlfile);
    env=fc_vfemp1.environment();
    try
      untar(urlfile,env.Path);
    catch
      error('Unable to get :\n  -> %s\n',urlfile);
    end
    % untar in directory fc-vfemp1/mfc-vfemp1-<name>-<version>
    %copyfile([env.Path,filesep,base,filesep,'*'],'.')
    %rmdir([env.Path,filesep,base],'s')
    if fc_tools.comp.isOctave()
      % rehash not works
      fprintf('\n*** Needs restart Octave for using <%s> add-on! ***\n',R.name)
    else
      eval(['Ver=fc_vfemp1.addon.',R.name,'.version();']);
      fprintf('Addon %s version %s successfully installed\n',R.name,Ver);
    end
    return
  end
  fprintf('Not yet implemented\n')
end


function V=GetVersions(urlbase,name)
  urlfile=[urlbase,name,filesep,'list.txt'];
  urlwrite(urlfile,'list.txt');
  fid=fopen('list.txt','r');assert(fid>0)
  L=fgetl(fid);
  assert(strcmp(L,['# versions ',name]))
  i=1;
  V={};
  while 1
    tline = fgetl(fid);
    if ~ischar(tline), break, end
    tline=strtrim(tline);
    if (tline(1)~='#')
      V{i}=tline;
      i=i+1;
    end
  end
  fclose(fid);
  assert(length(V)>0)
end

% check if current fc-vfemp1 version is compatible with addon
function bool=checkversion(urlfile)
  I=strfind(urlfile,'/');
  descname=[urlfile(1:I(end)),'desc.m'];
  urlwrite(descname,'desc_file.m');
  desc_file;
  bool=fc_tools.utils.strversion2num(desc.fc_vfemp1)<=fc_tools.utils.strversion2num(fc_vfemp1.version());
  delete('desc_file.m')
end
